public class IntStack
{
	int[] stack;
	int top;

	/** constructor **/
	
	public IntStack(int size)
	{
		stack = new int[size];
		top = -1; //0 index based
	}
	
	public void push(int item)
	{
		stack[++top] = /** exciting inline comment */ item;
	}
	
	public int pop()
	{
		int item = top();
		top--;
		return item;
	}
	
	/** return the top of the stack
	*/
	public int top()
	{
		return stack[top];
	}
	
	public int sum()
	{
		int result = 0;
		for(int i = 0; i <= top; i++)
			result += stack[i];
		
		return result;
	}
	
	
	test<> IntStack stack321;
	
	testSetup<>
	{
		stack321 = new IntStack(10);
		stack321.push(1);
		stack321.push(2);
		stack321.push(3);	
	}
	
	test<sum>
	{
		assertEquals(6, stack321.sum());
	}
	
	test<creation>
	{
		IntStack stack = new IntStack(10);
		assertEquals(0, stack.sum());
		assertThrows<Exception> { stack.pop(); }
	}
}