package ca.ubc.cs.elide.transforms;
import ca.ubc.cs.elide.transformations.*;
import ca.ubc.cs.elide.nodes.*;
import ca.ubc.cs.elide.*;
import java.util.*;


public class Uses extends Transform
{
       private static Set dependencySet = new HashSet();
        private static Dependency transformDependency = new Dependency("transform", "Uses");
        public static Set getDependencySet(Class self) { return dependencySet; }
        
        static
        {
                dependencySet.add(transformDependency);
        }
        
        static
        {
                transformDependency.addSatisfies("methodDefinition");
                transformDependency.addRequires("primitive");
        }
		
		public void transform(MethodNode method, String tfm)
		{
			method.getDeclaringClass().extend("static { Transform.registerTransform(\"" + tfm + "\"); }");
		}	
}